/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* $Id: caps.c,v 1.2 1999/03/22 09:46:59 elca Exp $ */

#include "Xatm.h"
#include "termcap.h"

/****************************************************************
 * cap եλؼ˽entry, vals ¤Τ񤭴롣
 */
int xatm_caps_change(FontEntryPtr    entry,
		     FontScalablePtr vals)
{
	char fontName[MAXFONTFILENAMELEN];
	char termcap_buf[2048];
	char * ptr;
	double x,y;

	xatm_get_fontname(entry->u.scalable.fileName, fontName);

	/* եȤ꤬ʤ BadFontName ֤
	   ξϥ顼ˤΤǤϤʤ
	   Ĥʤäݤϥǥեͤ
	   Ȥ褦ˤ롣 */
	if(tgetent(termcap_buf, fontName) < 1) {
		return BadFontName;
	}

	/* italic */
        if(tgetflag("it")) {
		vals->pixel_matrix[2] += vals->pixel_matrix[3] * 0.25;
		vals->point_matrix[2] += vals->point_matrix[3] * 0.25;
	}

	/* box size */
	if((ptr = tgetstr("bx", NULL)) != NULL) {
		if ( 2 == sscanf(ptr, "%lf,%lf", &x, &y)) {
			vals->pixel_matrix[0] *= x;
			vals->pixel_matrix[1] *= y;
			vals->pixel_matrix[2] *= x;
			vals->pixel_matrix[3] *= y;
			vals->point_matrix[0] *= x;
			vals->point_matrix[1] *= y;
			vals->point_matrix[2] *= x;
			vals->point_matrix[3] *= y;
		}
		free(ptr);
		/*printf("bx: %f, %f\n", x, y);*/
	}

	return Successful;
}

/****************************************************************
 * cap եλؼ˽XatmFont ¤Τ񤭴롣
 */
int xatm_caps_change_xatm(FontEntryPtr entry,
			  XatmFontPtr  xatm)
{
	char fontName[MAXFONTFILENAMELEN];
	char termcap_buf[2048];
	char * ptr;
	double x,y;

	xatm_get_fontname(entry->u.scalable.fileName, fontName);

	/* եȤ꤬ʤ BadFontName ֤
	   ξϥ顼ˤΤǤϤʤ
	   Ĥʤäݤϥǥեͤ
	   Ȥ褦ˤ롣 */
	if(tgetent(termcap_buf, fontName) < 1) {
		return BadFontName;
	}

	if((ptr = tgetstr("gx", NULL)) != NULL) {
		if ( 2 == sscanf(ptr, "%lf,%lf", &x, &y)) {
			xatm->matrix[0] *= x;
			xatm->matrix[1] *= y;
			xatm->matrix[2] *= x;
			xatm->matrix[3] *= y;
		}
		free(ptr);
	}

	if((ptr = tgetstr("de", NULL)) != NULL) {
		if ( 2 == sscanf(ptr, "%lf,%lf", &x, &y)) {
			xatm->delta_x = x;
			xatm->delta_y = y;
		}
		free(ptr);
	}

	/* fontname */
	if((ptr = tgetstr("fn", NULL)) != NULL) {
		xfree(xatm->fontname);
		xatm->fontname = ptr;
		/*printf("fontname change %s\n", xatm->fontname);*/
	}

	return Successful;
}

/* end */
